ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Types.CompleteMatch

Description

COMPLETE signature

Synopsis

- data CompleteMatch = CompleteMatch {
  - cmConLikes :: UniqDSet ConLike
  - cmResultTyCon :: Maybe TyCon
  }
- vanillaCompleteMatch :: UniqDSet ConLike -> CompleteMatch
- type CompleteMatches = [CompleteMatch]
- completeMatchAppliesAtType :: Type -> CompleteMatch -> Bool

# Documentation

data CompleteMatch Source #

A list of conlikes which represents a complete pattern match. These arise from `COMPLETE` signatures. See also Note [Implementation of COMPLETE pragmas].

Constructors

CompleteMatch |

Fields

- cmConLikes :: UniqDSet ConLike

  The set of `ConLike` values

- cmResultTyCon :: Maybe TyCon

  The optional, concrete result TyCon the set applies to

#### Instances

Instances details

Outputable CompleteMatch Source # |
Instance details Defined in GHC.Types.CompleteMatch Methods ppr :: CompleteMatch -> SDoc Source #

vanillaCompleteMatch :: UniqDSet ConLike -> CompleteMatch Source #

type CompleteMatches = [CompleteMatch] Source #

completeMatchAppliesAtType :: Type -> CompleteMatch -> Bool Source #